<div align="center">
  <img width="40%" src="docs/_static/dragonos-logo.svg" alt="dragonos-logo"></br>
  <h2>打造完全自主可控的数字化未来！</h2>

<a href="https://dragonos.org"><img alt="官网" src="https://img.shields.io/badge/%E5%AE%98%E7%BD%91-DragonOS.org-4c69e4?link=https%3A%2F%2Fbbs.dragonos.org.cn" ></a>
<a href="https://bbs.dragonos.org.cn"><img alt="bbs" src="https://img.shields.io/badge/BBS-bbs.dragonos.org.cn-purple?link=https%3A%2F%2Fbbs.dragonos.org.cn" ></a>



--- 

</div>

# DragonOS

**Languages** [中文](README.md)|English

&nbsp;

&emsp;&emsp;DragonOS is a 64-bit operating system designed for lightweight cloud computing scenarios, featuring a fully independent kernel and offering Linux binary compatibility. Developed using the Rust programming language, it aims to provide improved reliability. In the Rust operating system domain, DragonOS consistently ranks among the top three on GitHub nationally.

&emsp;&emsp;The DragonOS open-source community was established in July 2022 and is entirely business-neutral. Our goal is to build a fully independent, open-source, high-performance, and highly reliable server operating system, fostering a digitally autonomous and controllable future!

&emsp;&emsp;DragonOS boasts an excellent and comprehensive architecture design. Compared to other systems of similar scale, DragonOS supports virtualization and has certain advantages in terms of device model and调度子系统 (scheduler subsystem).Currently, significant efforts are being made to promote cloud platform support, RISC-V compatibility, and the porting of compilers and application software. The aim is to achieve large-scale application in production environments within five years.

&emsp;&emsp;Driven by the community, DragonOS is currently evolving rapidly. DragonOS has already implemented about 1/4 of Linux interfaces, and in the future, we will strive to provide 100% compatibility with Linux, along with new features.


## Get Involved in Development?

Carefully read the [DragonOS Community Introduction Document] to understand how the community operates and how you can contribute!

- **To stay updated on development news and tasks, visit the DragonOS Community Forum**: [https://bbs.dragonos.org.cn](https://bbs.dragonos.org.cn)
- You can also learn about the development progress by checking the project's issues.

&emsp;&emsp;If you're interested in joining us, you can check out the issues and post your discussions or ideas under them, or visit the DragonOS forum to learn about development updates and tasks: [https://bbs.dragonos.org.cn](https://bbs.dragonos.org.cn)

&emsp;&emsp;You're also welcome to bring your creative ideas and discuss them with the community members, working together to create new features for DragonOS.


## Website

- **Project's Website**: [DragonOS.org](https://dragonos.org)
- Documentation: [docs.dragonos.org](https://docs.dragonos.org)
- Community Introduction Document: [community.dragonos.org](https://community.dragonos.org)

## How to Run?

&emsp;&emsp;Running DragonOS is quite straightforward. You can refer to the following resources and get DragonOS up and running in as little as 15 minutes!

- [Building DragonOS — DragonOS Development Documentation](https://docs.dragonos.org/zh_CN/latest/introduction/build_system.html)

## How to Connect with the Community?

Please read the [Contributor Guide](https://community.dragonos.org/contributors/#%E7%A4%BE%E5%8C%BA)~

- You can establish contact with the members of various committees through the [Community Management Team] information.
- Additionally, you can find the contact information of the respective community group leaders via the [SIGs] and [WGs] pages.


## Reward

&emsp;&emsp;DragonOS is an open source public welfare project, but its development cannot be separated from the support of funds. If you want, you can visit **[Sponsor - DragonOS](https://dragonos.org/?page_id=37)** , so as to promote the development of this project. The list of all sponsors will be published. Every bit of your sponsorship will contribute to the development of DragonOS!

### Where will the sponsorship funds be used?

We guarantee that all sponsorship funds and items will be used for:

- Subsidies or equipment support for active community developers
- Cloud service expenditure of DragonOS
- Equipment purchase
- Any use conducive to the development and construction of DragonOS

### Sponsor List

**Not yet**

- **[China YaCloud](https://yacloud.net)** Ya'an Digital Economy Operations Co., Ltd. provides cloud server support for DragonOS.

### Individual Sponsor List


- 万晓兰
- David Wen
- [YJwu2023](https://github.com/YJwu2023)
- [longjin](https://github.com/fslongjin)
- [黄铭涛](https://github.com/1037827920)
- [许梓毫](https://github.com/Jomocool)
- [谢润霖](https://github.com/xiaolin2004)
- [蔡俊源](https://github.com/SMALLC04)
- Kelly
- [Samuka007](https://github.com/Samuka007)
- [杨璐玮](https://github.com/val213)
- [何懿聪](https://github.com/GnoCiYeH)
- [周凯韬](https://github.com/laokengwt)
- [Seele.Clover](https://github.com/seeleclover)
- [FindWangHao](https://github.com/FindWangHao)
- [ferchiel](https://github.com/ferchiel)
- 叶锦毅
- 林
- Albert
- [TerryLeeSCUT · GitHub](https://github.com/TerryLeeSCUT)
- slientbard
- 悟

## Open source statement

&emsp;&emsp;This project adopts GPLv2 LICENSE for open source. You are welcome to use the code of this project on the basis of abiding by the open source license!

**What we support:** using this project to create greater value and contribute code to this project under the condition of abiding by the agreement.

**What we condemn**: any non-compliance with the open source license. Including but not limited to: plagiarizing the code of the project as your graduation project and other academic misconduct, as well as commercial closed source use without payment.

If you find any violation of the open source license, we welcome you to send email feedback! Let's build an honest open source community together!

[DragonOS Community Introduction Document]: https://community.dragonos.org/
[Community Management Team]: https://community.dragonos.org/governance/staff-info.html
[SIGs]: https://community.dragonos.org/sigs/
[WGs]: https://community.dragonos.org/wgs/
